/* transitionaciones */

* { box-sizing: border-box; }

html {
  font-family: sans-serif;
  font-size: 16px;
  margin: 0;
  padding: 0;
}

body {
  margin: 40px;
}

.monotype {
  font-family: monospace;
  background-color: khaki;
  padding: 4px 8px;
  border-radius: 4px;
}

.transition-container {
  background-color: grey;
  display: block;
  /* width: 200px; */
  height: 100px;
  margin-bottom: 20px;
  padding: 5px;

  background-color: #f7f7f7;
  border-radius: 3px;
  padding: 10px;

  /* margin: 0 auto 40px; */
}

  .transition-item {
    font-size: 20px;
    /* text-align: center; */
    border-radius: 4px;
    background-color: rgba(162, 203, 250, 0.8);
    border: 1px solid #4390E1;
    box-sizing: border-box;
    box-shadow: 0 2px 2px rgba(0,90,250,0.05), 0 4px 4px rgba(0,90,250,0.05), 0 8px 8px rgba(0,90,250,0.05), 0 16px 16px rgba(0,90,250,0.05);
    width: 80px;
    height: 80px;
    position: relative;
    z-index: 10;

    /* margin: 0 auto 40px; */
  }

  .transition-ghost {
    font-size: 20px;
    /* text-align: center; */
    border-radius: 4px;
    border: 3px dashed #4390E1;
    box-sizing: border-box;
    width: 82px;
    height: 82px;
    position: absolute;
    /* left: 50%; */
    z-index: 8;
    /* margin-left: -81px; */
    margin-left: -1px;
    margin-top: -1px;
  }

  /* .transition-item:after {
      content: '';
      background: #db3951;
      -webkit-transition: scale(0.1);
      transition: scale(0.1);
      display: block;
      width: 100%;
      height: 100%;
      position: absolute;
      top: 0;
      left: 0;
      border: solid 1px #db3951;
      -webkit-transition-origin: inherit;
      transition-origin: inherit;
  } */


/* 1. transition-timing-function */

.ease-a .transition-item {
  transition: width 1s linear;
}

.ease-b .transition-item {
  transition: width 1s ease-in;
}

.ease-c .transition-item {
  transition: width 1s ease-out;
}

.ease-d .transition-item {
  transition: width 1s ease-in-out;
}

.ease-e .transition-item {
  transition: width 1s cubic-bezier(0.165, 0.84, 0.44, 1);
}

.transition-timing:hover .transition-item {
  width: 100%;
}


/* 2. transition-delay */

.delay-a .transition-item {
  transition: width 1s ease-in;
}

.delay-b .transition-item {
  transition: width 1s ease-in .1s;
}

.delay-c .transition-item {
  transition: width 1s ease-in .2s;
}

.transition-delay:hover .transition-item {
  width: 100%;
}


/* 3. Multiples valores */

.multiple-a .transition-item {
  transition: transform 1s ease-in;
}

.multiple-b .transition-item {
  transition: transform 1s ease-in;
}

.multiple-c .transition-item {
  transition: transform 1s ease-in, background-color 1s linear;
}

.transition-multiple:hover .multiple-a .transition-item {
  transform: skew(45deg) translateX(400px);
}

.transition-multiple:hover .multiple-b .transition-item {
  transform: perspective(100px) rotateX(180deg);
}

.transition-multiple:hover .multiple-c .transition-item {
  transform: rotate(180deg);
  background-color: lightpink;
}


/* 4. Concatenar animaciones */

.concat-a .transition-item {
  transition: transform 1s ease-in, background-color 1s linear 1s;
}

.concat-b .transition-item {
  transition: transform 1s ease-in, background-color 1s linear;
}

.transition-concat:hover .concat-a .transition-item {
  transform: translateX(400px);
  background-color: lightpink;
}

.transition-concat:hover .concat-b .transition-item {
  transform: translateX(400px);
  background-color: lightpink;
}


/* 4. El orden es importante  */

.origin-a .transition-item {
  transition: transform 3s ease-in;
}

.origin-b .transition-item {
  transition: transform 1s ease-in;
}

.transition-origin:hover .origin-a .transition-item {
  transform: translateX(600px) rotate(180deg);
}

.transition-origin:hover .origin-b .transition-item {
  transform: rotate(-180deg) translateX(600px);
}


